use aoc2023_niels_overkamp::common::{self, AOCResult};
use std::collections::HashSet;

const DAY: &str = "day11";

fn main() -> Result<(), Box<dyn std::error::Error>> {
    common::run(DAY, &run)
}

pub fn run(input: &Vec<String>) -> AOCResult {
    let mut galaxy_rows = HashSet::new();
    let mut galaxy_columns = HashSet::new();
    let mut galaxies = vec![];
    
    let (mut x, mut y) = (0usize, 0usize);    
    for line in input.iter() {
        x = 0;
        for byte in line.as_bytes().iter() {
            if *byte == b'#' {
                galaxy_rows.insert(y);
                galaxy_columns.insert(x);
                galaxies.push((x,y));
            }
            x += 1;
        }
        y += 1
    }
    
    let mut expand_map_rows = vec![];
    let mut expand_map_columns = vec![];
    
    let mut expansion = 0;
    for x in 0..x {
        if !galaxy_columns.contains(&x) {
            expansion += 1;
        }
        expand_map_columns.push(expansion)
    }
    
    expansion = 0;
    for y in 0..y {
        if !galaxy_rows.contains(&y) {
            expansion += 1;
        }
        expand_map_rows.push(expansion)
    }
    
    println!("{:?}", expand_map_columns);
    println!("{:?}", expand_map_rows);
    
    let mut old_galaxies = galaxies.clone();
    
    for (x, y) in galaxies.iter_mut() {
        *x += expand_map_columns[*x];
        *y += expand_map_rows[*y];
    }
    
    for (x, y) in old_galaxies.iter_mut() {
        *x += (1_000_000 - 1) * expand_map_columns[*x];
        *y += (1_000_000 - 1) * expand_map_rows[*y];
    }
    
    println!("{:?}", galaxies);
    println!("{:?}", old_galaxies);
    
    let mut distance_sum = 0;
    for (i, (x0, y0)) in galaxies.iter().enumerate() {
        for (x1, y1) in galaxies[i+1..].iter() {
            distance_sum += (*x1).abs_diff(*x0) + (*y1).abs_diff(*y0);
        }
    }
    
    let mut old_distance_sum = 0;
    for (i, (x0, y0)) in old_galaxies.iter().enumerate() {
        for (x1, y1) in old_galaxies[i+1..].iter() {
            old_distance_sum += (*x1).abs_diff(*x0) + (*y1).abs_diff(*y0);
        }
    }
    
    Ok([Some(distance_sum.to_string()), Some(old_distance_sum.to_string())])
}

#[test]
pub fn test_day11() {
    assert!(common::run_test(DAY, &run))
}
