use aoc2023_niels_overkamp::common::{self, AOCResult};

const DAY: &str = "day9";

fn main() -> Result<(), Box<dyn std::error::Error>> {
    common::run(DAY, &run)
}

pub fn run(input: &Vec<String>) -> AOCResult {
    let mut right_sum: isize = 0;
    let mut left_sum: isize = 0;
    for line in input.into_iter() {
        let mut series = line.split(' ').map(str::parse::<isize>).collect::<Result<Vec<_>, _>>()?;
        let mut right_sum_list = vec![];
        let mut left_sum_list = vec![];
        while series.len() > 1 && !series.iter().all(|&x| x == 0) {
            left_sum_list.push(series[0]);
            for i in 0..(series.len() - 1) {
                series[i] = series[i + 1] - series[i];
            }
            right_sum_list.push(series.pop().unwrap());
        }
        println!("{:?}", line);
        println!("{:?}", series);
        println!("{:?}", right_sum_list);
        println!("{:?} {}", left_sum_list, left_sum_list.iter().rev().fold(0, |acc, n| n - acc));
        if series[0] != 0 {
            return Err(format!("Series did not converge to 0's {}", line).into());
        }
        right_sum += right_sum_list.into_iter().sum::<isize>();
        left_sum += left_sum_list.iter().rev().fold(0, |acc, n| n - acc);
    }
    

    Ok([Some(right_sum.to_string()), Some(left_sum.to_string())])
}

#[test]
pub fn test_day9() {
    assert!(common::run_test(DAY, &run))
}
